#
# spec file for package memtest86+ (Version 4.0)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#
%define _default_patch_fuzz 2

Name:           memtest86
Version:        4.0s
Release:        1.1
#
License:        BSD 3-Clause
Group:          System/Boot
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%ifarch x86_64
BuildRequires:  glibc-devel-32bit
%endif
ExclusiveArch: %ix86 x86_64
Provides:       lilo:/boot/memtest86.bin
#
URL:            http://www.memtest86.com
Source:         http://memtest86.com/%{version}/%{name}-%{version}.tar.bz2
Source1:	%{name}-rpmlintrc
Patch0:         fix-destdir
#
Summary:        Memory Testing Image for x86 Architecture

%description
Memtest86 is an image that can be booted instead of a real OS. Once
booted, it can be used to test the computer's memory.

%prep
%setup
%patch0 -p1

%build
%ifarch x86_64
  make CC="gcc -m32" AS="as --32"
%else
  make
%endif

%install
install -D -m 0644 memtest.bin $RPM_BUILD_ROOT/boot/memtest86.bin

%post
if [ "$YAST_IS_RUNNING" != instsys -a $1 = 1 -a \
	 -x /sbin/update-bootloader ]; then
	/sbin/update-bootloader --add --image /boot/memtest86.bin --name "Memory Test (memtest86)"
fi
true

%postun
test -x /sbin/update-bootloader && /sbin/update-bootloader --remove --force --image /boot/memtest86.bin || true

%files
%defattr(-,root,root)
/boot/memtest86.bin
%doc README*

%changelog
* Wed Oct  3 2012 cs@linux-administrator.com
- update to release 4.0s
* Sun Apr 17 2011 cs@linux-administrator.com
- update to release 4.0
  * Support for testing with multiple CPUs. All tests except
    for #11 (Bit Fade) have been multi-threaded.
    A maximum of 16 CPUs will be used for testing.
  * CPU detection has been completely re-written to use the
    brand ID string rather than the cumbersome, difficult to
    maintain and often out of date CPUID family information.
    All new processors will now be correctly identified without
    requiring code support.
  * All code related to controller identification, PCI and DMI
    has been removed. This may be a controversial decision and
    was not made lightly. The following are justifications
    for the decision:
    1. Controller identification has nothing to do with actual
    testing of memory, the core purpose of Memtest86.
    2. This code needed to be updated with every new chipset.
    With the ever growing number of chipsets it is not
    possible to keep up with the changes. The result is that
    new chipsets were more often than not reported in-correctly.
    In the authors opinion incorrect information
    is worse than no information.
    3. Probing for chipset information carries the risk of
    making the program crash.
    4. The amount of code involved with controller identification
    was quite large, making support more difficult.
    Removing this code also had the unfortunate effect of removing
    reporting of correctable ECC errors. The code to support ECC
    was hopelessly intertwined the controller identification code.
    A fresh, streamlined implementation of ECC reporting is planned
    for a future release.
  * A surprising number of conditions existed that potentially cause
    problems when testing more than 4 GB of memory. Most if not all
    of these conditions have been identified and corrected.
  * A number of cases were corrected where not all of memory was
    being tested. For most tests the last word of each test block
    was not tested. In addition an error in the paging code was
    fixed that omitted from testing the last 256 bytes of each
    block above 2 GB.
  * The information display has been simplified and a number of
    details that were not relevant to testing were removed.
  * Memory speed measurement has been parallelized for more accurate
    reporting for multi channel memory controllers.
  * This is a major re-write of the Memtest86 with a large number of
    minor bug-fixes and substantial cleanup and
    re-organization of the code.
